VERSION 5.00
Begin VB.Form main 
   Caption         =   "FT245 FIFO Controller"
   ClientHeight    =   6210
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4635
   LinkTopic       =   "Form1"
   ScaleHeight     =   6210
   ScaleWidth      =   4635
   StartUpPosition =   1  'CenterOwner
   Begin VB.CheckBox Check1 
      Caption         =   "Auto"
      Height          =   315
      Left            =   1980
      TabIndex        =   19
      Top             =   3840
      Width           =   795
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   3240
      Top             =   1680
   End
   Begin VB.TextBox stat 
      Alignment       =   2  'Center
      Height          =   315
      Index           =   3
      Left            =   2520
      TabIndex        =   18
      Top             =   1320
      Width           =   1995
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Purge"
      Height          =   315
      Index           =   9
      Left            =   3780
      TabIndex        =   17
      Top             =   1740
      Width           =   735
   End
   Begin VB.TextBox stat 
      Height          =   1755
      Index           =   8
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   16
      Top             =   4200
      Width           =   4395
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Read Buffer"
      Height          =   315
      Index           =   8
      Left            =   120
      TabIndex        =   15
      Top             =   3840
      Width           =   1755
   End
   Begin VB.TextBox stat 
      Alignment       =   2  'Center
      Height          =   315
      Index           =   7
      Left            =   2640
      TabIndex        =   14
      Top             =   3840
      Width           =   615
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Buffer Size"
      Height          =   315
      Index           =   5
      Left            =   3300
      TabIndex        =   13
      Top             =   3840
      Width           =   1155
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Write to FIFO"
      Height          =   315
      Index           =   7
      Left            =   120
      TabIndex        =   12
      Top             =   1740
      Width           =   1635
   End
   Begin VB.TextBox stat 
      Height          =   1635
      Index           =   6
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   11
      Top             =   2100
      Width           =   4395
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Open Device Info"
      Height          =   315
      Index           =   6
      Left            =   120
      TabIndex        =   10
      Top             =   900
      Width           =   1635
   End
   Begin VB.TextBox stat 
      Alignment       =   2  'Center
      Height          =   315
      Index           =   4
      Left            =   1800
      TabIndex        =   9
      Top             =   1320
      Width           =   615
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Close"
      Height          =   315
      Index           =   4
      Left            =   960
      TabIndex        =   8
      Top             =   1320
      Width           =   795
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Open"
      Height          =   315
      Index           =   3
      Left            =   120
      TabIndex        =   7
      Top             =   1320
      Width           =   795
   End
   Begin VB.TextBox stat 
      Alignment       =   2  'Center
      Height          =   315
      Index           =   1
      Left            =   4140
      TabIndex        =   4
      Top             =   120
      Width           =   375
   End
   Begin VB.TextBox stat 
      Alignment       =   2  'Center
      Height          =   675
      Index           =   2
      Left            =   1800
      MultiLine       =   -1  'True
      TabIndex        =   3
      Top             =   540
      Width           =   2715
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Description"
      Height          =   315
      Index           =   1
      Left            =   120
      TabIndex        =   2
      Top             =   540
      Width           =   1635
   End
   Begin VB.TextBox stat 
      Alignment       =   2  'Center
      Height          =   315
      Index           =   0
      Left            =   2460
      TabIndex        =   1
      Top             =   120
      Width           =   375
   End
   Begin VB.CommandButton Command1 
      Caption         =   "DeviceCount"
      Height          =   315
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1635
   End
   Begin VB.Label Label1 
      Caption         =   "Selected device"
      Height          =   255
      Index           =   1
      Left            =   2940
      TabIndex        =   6
      Top             =   180
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Devices"
      Height          =   255
      Index           =   0
      Left            =   1800
      TabIndex        =   5
      Top             =   180
      Width           =   675
   End
End
Attribute VB_Name = "main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Check1_Click()

If Check1.Value = Checked Then
  stat(8) = ""
  Timer1.Enabled = True
Else
  Timer1.Enabled = False
End If

End Sub

Private Sub Command1_Click(Index As Integer)

If (Index > 0) And Val(stat(0)) = 0 Then
  Exit Sub
End If

stat(1) = Val(stat(1))
If Val(stat(1)) < 0 Then
  stat(1) = 0
End If
If Val(stat(1)) > Val(stat(0)) - 1 Then
  stat(1) = Val(stat(0)) - 1
End If

Select Case Index
  Case 0
    'get device count
    stat(0) = fifo_devices
    stat(1) = 0
  Case 1
    'fifo description, if the port is open, can't read it this way
    stat(2) = fifo_infolist(Val(stat(1)))
  Case 6
    'currently open device info
    stat(2) = fifo_infoopen
  Case 3
    'open port
    Call fifo_close
    fifo_open (Val(stat(1)))
  Case 4
    'close port
    Call fifo_close
  Case 7
    'write stat(6) to port if open
    If fifo_status Then
      fifo_write (stat(6))
    Else
      Beep
    End If
  Case 8
    'read whole buffer
    If fifo_status Then
      stat(8) = fifo_readall()
      stat(7) = Len(stat(8))
    Else
      Beep
    End If
  Case 5
    'rx buffer size
    If fifo_status Then
      stat(7) = fifo_rxwaiting
    Else
      Beep
    End If
  Case 9
    'purge buffers
    If fifo_status Then
      fifo_purge
    Else
      Beep
    End If
End Select

If fifo_status = True Then
  stat(4) = "True"
Else
  stat(4) = "False"
End If

stat(3) = fifo_errormode()

End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

Call fifo_close

End Sub


Private Sub Form_Terminate()

fifo_close

End Sub


Private Sub Timer1_Timer()

If fifo_status Then
  stat(8) = stat(8) + fifo_readall()
End If

End Sub


