Attribute VB_Name = "FT245"
Option Explicit
'////////////////////////////////////////////////////////////////////////////////////////////////////
'true=port open, false=port closed
Public fifo_status As Boolean

'error decoded by fifo_errormode()
Public fifo_error As Long

'currently open device info
Public fifo_opendevice As String
Public fifo_handle As Long
'/////////////////////////////////////////////////////////////////////////////////////////////////////
'CLASSIC INTERFACE DECLARATIONS
Public Declare Function FT_ListDevices Lib "FTD2XX.DLL" ( _
                                    ByVal arg1 As Long, _
                                    ByVal arg2 As String, _
                                    ByVal dwFlags As Long) As Long
                                    
Public Declare Function FT_GetNumDevices Lib "FTD2XX.DLL" Alias "FT_ListDevices" ( _
                                    ByRef arg1 As Long, _
                                    ByVal arg2 As String, _
                                    ByVal dwFlags As Long) As Long
                                    
Public Declare Function FT_Open Lib "FTD2XX.DLL" ( _
                                    ByVal intDeviceNumber As Integer, _
                                    ByRef lngHandle As Long) As Long
                                    
Public Declare Function FT_OpenEx Lib "FTD2XX.DLL" ( _
                                    ByVal arg1 As String, _
                                    ByVal arg2 As Long, _
                                    ByRef lngHandle As Long) As Long
                                    
Public Declare Function FT_Close Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long) As Long
                                    
Public Declare Function FT_Read Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByVal lpszBuffer As String, _
                                    ByVal lngBufferSize As Long, _
                                    ByRef lngBytesReturned As Long) As Long
                                    
Public Declare Function FT_Write Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByVal lpszBuffer As String, _
                                    ByVal lngBufferSize As Long, _
                                    ByRef lngBytesWritten As Long) As Long
                                    
Public Declare Function FT_WriteByte Lib "FTD2XX.DLL" Alias "FT_Write" ( _
                                    ByVal lngHandle As Long, _
                                    ByRef lpszBuffer As Any, _
                                    ByVal lngBufferSize As Long, _
                                    ByRef lngBytesWritten As Long) As Long
                                    
Public Declare Function FT_SetBaudRate Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByVal lngBaudRate As Long) As Long
                                    
Public Declare Function FT_SetDataCharacteristics Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByVal byWordLength As Byte, _
                                    ByVal byStopBits As Byte, _
                                    ByVal byParity As Byte) As Long
                                    
Public Declare Function FT_SetFlowControl Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByVal intFlowControl As Integer, _
                                    ByVal byXonChar As Byte, _
                                    ByVal byXoffChar As Byte) As Long
                                    
Public Declare Function FT_SetDtr Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long) As Long
                                    
Public Declare Function FT_ClrDtr Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long) As Long
                                    
Public Declare Function FT_SetRts Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long) As Long
                                    
Public Declare Function FT_ClrRts Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long) As Long
                                    
Public Declare Function FT_GetModemStatus Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByRef lngModemStatus As Long) As Long
                                    
Public Declare Function FT_SetChars Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByVal byEventChar As Byte, _
                                    ByVal byEventCharEnabled As Byte, _
                                    ByVal byErrorChar As Byte, _
                                    ByVal byErrorCharEnabled As Byte) As Long
                                    
Public Declare Function FT_Purge Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByVal lngMask As Long) As Long
                                    
Public Declare Function FT_SetTimeouts Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByVal lngReadTimeout As Long, _
                                    ByVal lngWriteTimeout As Long) As Long
                                    
Public Declare Function FT_GetQueueStatus Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByRef lngRxBytes As Long) As Long
                                    
Public Declare Function FT_SetBreakOn Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long) As Long
                                    
Public Declare Function FT_SetBreakOff Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long) As Long
                                    
Public Declare Function FT_GetStatus Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByRef lngRxBytes As Long, _
                                    ByRef lngTxBytes As Long, _
                                    ByRef lngEventsDWord As Long) As Long
                                    
Public Declare Function FT_SetEventNotification Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByVal dwEventMask As Long, _
                                    ByVal pVoid As Long) As Long
                                    
Public Declare Function FT_ResetDevice Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long) As Long
                                    
Public Declare Function FT_GetBitMode Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByRef intData As Any) As Long
                                    
Public Declare Function FT_SetBitMode Lib "FTD2XX.DLL" ( _
                                    ByVal lngHandle As Long, _
                                    ByVal intMask As Byte, _
                                    ByVal intMode As Byte) As Long
                                    
Public Declare Function FT_SetLatencyTimer Lib "FTD2XX.DLL" ( _
                                    ByVal Handle As Long, _
                                    ByVal pucTimer As Byte) As Long
                                    
Public Declare Function FT_GetLatencyTimer Lib "FTD2XX.DLL" ( _
                                    ByVal Handle As Long, _
                                    ByRef ucTimer As Long) As Long
'//////////////////////////////////////////////////////////////////////////////////////////////////
'error codes
Public Const FT_OK = 0
Public Const FT_INVALID_HANDLE = 1
Public Const FT_DEVICE_NOT_FOUND = 2
Public Const FT_DEVICE_NOT_OPENED = 3
Public Const FT_IO_ERROR = 4
Public Const FT_INSUFFICIENT_RESOURCES = 5
Public Const FT_INVALID_PARAMETER = 6
Public Const FT_INVALID_BAUD_RATE = 7
Public Const FT_DEVICE_NOT_OPENED_FOR_ERASE = 8
Public Const FT_DEVICE_NOT_OPENED_FOR_WRITE = 9
Public Const FT_FAILED_TO_WRITE_DEVICE = 10
Public Const FT_EEPROM_READ_FAILED = 11
Public Const FT_EEPROM_WRITE_FAILED = 12
Public Const FT_EEPROM_ERASE_FAILED = 13
Public Const FT_EEPROM_NOT_PRESENT = 14
Public Const FT_EEPROM_NOT_PROGRAMMED = 15
Public Const FT_INVALID_ARGS = 16
Public Const FT_NOT_SUPPORTED = 17
Public Const FT_OTHER_ERROR = 18

'flags for FT_OpenEx
Public Const FT_OPEN_BY_SERIAL_NUMBER = 1
Public Const FT_OPEN_BY_DESCRIPTION = 2

'flags for FT_ListDevices
Public Const FT_LIST_NUMBER_ONLY = &H80000000
Public Const FT_LIST_BY_INDEX = &H40000000
Public Const FT_LIST_ALL = &H20000000

'purge constants
Public Const FT_PURGE_RX = 1
Public Const FT_PURGE_TX = 2

Public Function fifo_close()
' close the currently open module

'not if not open
If Not fifo_status Then
  Exit Function
End If

'set the open device info to null now that its closed
fifo_opendevice = ""

'close and flag port as closed
fifo_error = FT_Close(fifo_handle)
fifo_status = False
  
End Function



Public Function fifo_errormode() As String
' show an error message
Dim description As String

Select Case fifo_error
    Case FT_OK
        description = "No error"
    Case FT_INVALID_HANDLE
        description = "Invalid Handle"
    Case FT_DEVICE_NOT_FOUND
        description = "Device Not Found"
    Case FT_DEVICE_NOT_OPENED
        description = "Device Not Opened"
    Case FT_IO_ERROR
        description = "General IO Error"
    Case FT_INSUFFICIENT_RESOURCES
        description = "Insufficient Resources"
    Case FT_INVALID_PARAMETER
        description = "Invalid Parameter"
    Case FT_INVALID_BAUD_RATE
        description = "Invalid Baud Rate"
    Case FT_DEVICE_NOT_OPENED_FOR_ERASE
        description = "Device not opened for Erase"
    Case FT_DEVICE_NOT_OPENED_FOR_WRITE
        description = "Device not opened for Write"
    Case FT_FAILED_TO_WRITE_DEVICE
        description = "Failed to write Device"
    Case FT_EEPROM_READ_FAILED
        description = "EEPROM read failed"
    Case FT_EEPROM_WRITE_FAILED
        description = "EEPROM write failed"
    Case FT_EEPROM_ERASE_FAILED
        description = "EEPROM erase failed"
    Case FT_EEPROM_NOT_PRESENT
        description = "EEPROM not present"
    Case FT_EEPROM_NOT_PROGRAMMED
        description = "EEPROM not programmed"
    Case FT_INVALID_ARGS
        description = "Invalid Arguments"
    Case FT_NOT_SUPPORTED
        description = "Function requested is not supported"
    Case FT_OTHER_ERROR
        description = "other error"
End Select

fifo_errormode = Str(fifo_error) + ": " + description

End Function

Public Function fifo_rxwaiting() As Long
' return the number of bytes waiting to be read
Dim ft_q_bytes As Long

'not if not open
If Not fifo_status Then
  Exit Function
End If

fifo_error = FT_GetQueueStatus(fifo_handle, ft_q_bytes)

If fifo_error = FT_OK Then
    fifo_rxwaiting = ft_q_bytes
End If

End Function

Public Function fifo_infoopen() As String
' get the device name of the currently open device

fifo_infoopen = fifo_opendevice
   
End Function

Public Function fifo_devices() As Long
' get the number of connected devices
Dim ft_device_count As Long
        
fifo_error = FT_GetNumDevices(ft_device_count, 0, FT_LIST_NUMBER_ONLY)
fifo_devices = ft_device_count
    
End Function

Public Function fifo_infolist(DeviceIndex As Long) As String
Dim FT_Device_String_Buffer As String * 50
    
fifo_error = FT_ListDevices(DeviceIndex, FT_Device_String_Buffer, (FT_OPEN_BY_DESCRIPTION Or FT_LIST_BY_INDEX))

If fifo_error = FT_OK Then
    'strip off trailing null characters
    fifo_infolist = Left(FT_Device_String_Buffer, InStr(FT_Device_String_Buffer, Chr(0)) - 1)
Else
    fifo_infolist = ""                 ' init to null
    Exit Function
End If
    
fifo_error = FT_ListDevices(DeviceIndex, FT_Device_String_Buffer, (FT_OPEN_BY_SERIAL_NUMBER Or FT_LIST_BY_INDEX))

If fifo_error = FT_OK Then
    ' strip off trailing nulls
    fifo_infolist = fifo_infolist + Chr(13) + Chr(10) + Left(FT_Device_String_Buffer, InStr(FT_Device_String_Buffer, Chr(0)) - 1)
Else
    ' init to null
    fifo_infolist = ""
End If
    
End Function










Public Function fifo_open(Device_index As Long) As Long

'get info from device before opening it and save for later
fifo_opendevice = fifo_infolist(Device_index)

'open the device
fifo_error = FT_Open(Device_index, fifo_handle)

If fifo_error = FT_OK Then
    fifo_status = True
Else
    fifo_status = False
End If
    
End Function


Public Function fifo_read(Read_Count As Long) As String
Dim Read_Result As Long
Dim rxsize As Long
Dim indata As String * 32767

'not if not open
If Not fifo_status Then
  Exit Function
End If

'why use timeouts when the calling program can just poll the rx queue
rxsize = fifo_rxwaiting
If Read_Count > rxsize Then
  Read_Count = rxsize
End If

'get the data
fifo_error = FT_Read(fifo_handle, indata, Read_Count, Read_Result)

'send the data
fifo_read = indata

End Function

Public Function fifo_readall() As String
Dim Read_Result As Long
Dim rxsize As Long
Dim inbuffer As String * 65526

'not if not open
If Not fifo_status Then
  Exit Function
End If

rxsize = fifo_rxwaiting
If rxsize = 0 Then
  fifo_readall = ""
Else
  fifo_error = FT_Read(fifo_handle, inbuffer, rxsize, Read_Result)
  fifo_readall = Mid(inbuffer, 1, rxsize)
End If

End Function

Public Function fifo_purge()

'not if not open
If Not fifo_status Then
  Exit Function
End If

fifo_error = FT_Purge(fifo_handle, FT_PURGE_RX Or FT_PURGE_TX)

End Function

Public Function fifo_reset()

'not if not open
If Not fifo_status Then
  Exit Function
End If

fifo_error = FT_ResetDevice(fifo_handle)

End Function



Public Function fifo_latency(ucLatency As Byte) As Long

'not if not open
If Not fifo_status Then
  Exit Function
End If

fifo_error = FT_SetLatencyTimer(fifo_handle, ucLatency)
    
End Function

Public Function fifo_timeout(readtimeoutmiliseconds As Long, writetimeoutmiliseconds As Long)

'not if not open
If Not fifo_status Then
  Exit Function
End If

fifo_error = FT_SetTimeouts(fifo_handle, readtimeoutmiliseconds, writetimeoutmiliseconds)
    
End Function





Public Function fifo_write(dataout As String)
Dim Write_Result As Long
Dim write_count As Long

'get the size
write_count = Len(dataout)

'not if not open
If Not fifo_status Then
  Exit Function
End If

'write the data
fifo_error = FT_Write(fifo_handle, dataout, write_count, Write_Result)
   
End Function
